***********************************************
*                                             *
*         BankBoot Routine 680xx              *
*                                             *
*        V1.0 20180217 Jens Mewes             *
*                                             *
***********************************************

 cpu      equ 1                 ; 1=68008, 2=68000
 bank     equ $ffffffc8*cpu     ; BankBoot Port

 org      0
 offset   $10000

 dc.l     $00008ffe             ; Dummy Stack
 dc.l     start                 ; Startadresse

start:                          ; Start 1. Stufe
 lea      $8000,a0              ; moegliches Zielgebiet fuer Kaltstart
 move.l   a0, d1
lp001:
 move.l   #$33ccaa55, (a0)
 cmp.l    #$33ccaa55, (a0)      ; RAM?
 beq.s    lp002                 ; ja
 adda.l   d1, a0                ; sonst Ziel um 32k erhoehen
 bra.s    lp001
lp002:
 movea.l  a0, a2                ; a2=Ziel
 move     #ende-anf-1, d3
lp003:
 lea      anf(pc), a1           ; Quelle
 move.b   (a1)+, (a0)+
 dbra     d3, lp003
 jmp      0(a2)                 ; ins Ziel springen

anf:                            ; Start 2. Stufe
 move.b   #$80, bank.w          ; 68008 loesche Banken
* move.w   #$8080, bank.w        ; 68000 loesche Banken
 lea      $400, a0              ; Start der Suche
loop:
 cmp.l    #$5aa58001,(a0)       ; GP Kennung
 beq.s    gefunden
 adda.l   #$1000, a0            ; alle 4k suchen nach Anfang
 beq.s    loop
gefunden:
 cmp      #$6000, $20(a0)       ; muss Sprung sein
 bne.s    loop
 cmp      #$6000, $24(a0)       ; muss auch Sprung sein
 bne.s    loop
 jmp      $24(a0)               ; Kalt-Start ausfuehren
ende:
 nop

 org      ende
 df.b     8192-ende, $ff        ; Fuer 68008
* df.b     16384-ende, $ff       ; Fuer 68000

 end
